﻿using Infragistics.Win;
using Infragistics.Win.SupportDialogs.RibbonCustomizationProvider;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinToolbars;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ToolbarsManagerCustomizationDialogDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.Load += Form1_Load;            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for(int i=0; i<4; i++)
            {
                ultraToolbarsManager1.Ribbon.Tabs.Add(new RibbonTab("Item" + i.ToString()) { Caption = "Tab Item " + i.ToString() });
            }
            
            ultraRibbonCustomizationProvider1.BeforeCustomizationDialogDisplayed += UltraRibbonCustomizationProvider1_BeforeCustomizationDialogDisplayed;            
        }

        private void UltraRibbonCustomizationProvider1_BeforeCustomizationDialogDisplayed(object sender, Infragistics.Win.SupportDialogs.RibbonCustomizationProvider.BeforeCustomizationDialogDisplayedEventArgs e)
        {
            RibbonCustomizationDialog dialog = e.Dialog;
            this.RecursiveControlGetAndRemovalOfItems(dialog);
        }   
        
        public void RecursiveControlGetAndRemovalOfItems(Control obj)
        {
            foreach(Control ctrl in obj.Controls)
            {               
                if(ctrl is UltraComboEditor)
                {
                    var combo = ctrl as UltraComboEditor;

                    ValueListItemsCollection collection = combo.ValueList.ValueListItems;

                    List<ValueListItem> itemsToRemove = new List<ValueListItem>();

                    foreach (ValueListItem item in collection)
                    {
                        if (item.DisplayText == "All Tabs" || item.DisplayText == "All Commands")
                        {
                            itemsToRemove.Add(item);
                        }
                    }

                    foreach(ValueListItem item in itemsToRemove)
                    {
                        collection.Remove(item);
                    }
                }

                this.RecursiveControlGetAndRemovalOfItems(ctrl);
            }
        }
    }
}
